#!/bin/sh
# Show that wc's new --files0-from option works.

if test "$VERBOSE" = yes; then
  set -x
  wc --version
fi

. $srcdir/../lang-default

pwd=`pwd`
t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$
trap 'status=$?; cd $pwd; chmod -R u+rwx $t0; rm -rf $t0 && exit $status' 0
trap '(exit $?); exit $?' 1 2 13 15

framework_failure=0
mkdir -p $tmp || framework_failure=1
cd $tmp || framework_failure=1

echo 2 > 2b || framework_failure=1
echo 2 words > 2w || framework_failure=1
printf '2b\n2w\n' |tr '\n' '\0' > names || framework_failure=1

if test $framework_failure = 1; then
  echo "$0: failure in testing framework" 1>&2
  (exit 1); exit 1
fi

fail=0

wc --files0-from=names > out || fail=1
cat <<\EOF > exp || fail=1
 1  1  2 2b
 1  2  8 2w
 2  3 10 total
EOF

cmp out exp || fail=1
test $fail = 1 && diff out exp 2> /dev/null

if test "$fail" = ''; then
  # Repeat the above test, but read the file name list from stdin.
  rm -f out
  wc --files0-from=- < names > out || fail=1
  cmp out exp || fail=1
  test $fail = 1 && diff out exp 2> /dev/null
fi

(exit $fail); exit $fail
